AchievementHandler = (function() {
    var constructor = function(achievementHandlerGuestRef, achievementHandlerRecognizedRef) {
	    var requestTypeHandled = 'AchievementRequest';
		
		var achievementHandlerGuest = achievementHandlerGuestRef;
	    var achievementHandlerRecognized = achievementHandlerRecognizedRef;
		
		this['getHandledType'] = function() {
		    return requestTypeHandled;
	    };
		
	    this['handleRequest'] = function(request) {
			var dfd = $.Deferred();
			
			if (!(request instanceof Request)) {
				console.log('AchievementHandler: handleRequest: input was not of type Request');
				/* TODO: Revise FAILURE result code */
				var result = new Result(constants.NativeCallResultCode.REQUEST_ERROR, {});
		        dfd.resolve(result);
			} else {
			    console.log('AchievementHandler: handleRequest: message is: ' + JSON.stringify(request.getType()));
				// Defer to appropriate handler based on whether user is a guest or is recognized
                ServiceFactory.getGCSettings().getGuestMode().always(function(globalGuestMode) {
				    var targetHandler = undefined;
					
				    var isGuest = globalGuestMode;
					if (isGuest) {
					    targetHandler = achievementHandlerGuest;
					} else {
					    targetHandler = achievementHandlerRecognized;
					}
					
					targetHandler.handleRequest(request).always(function(result) {
					    // We are acting as a pass-through.  Just return the result.
					    dfd.resolve(result);
					});
                });
		    }
			
			console.log('AchievementHandler: handleRequest: end of call');
			return dfd.promise();
		};
    };

    return constructor;
}());
console.log("AchievementHandler loaded.");