LeaderboardHandler = (function() {
    var constructor = function(leaderboardHandlerGuestRef, leaderboardHandlerRecognizedRef) {
	    var requestTypeHandled = 'LeaderboardRequest';
		
		var leaderboardHandlerGuest = leaderboardHandlerGuestRef;
	    var leaderboardHandlerRecognized = leaderboardHandlerRecognizedRef;
		
		this['getHandledType'] = function() {
		    return requestTypeHandled;
	    };
		
	    this['handleRequest'] = function(request) {
			var dfd = $.Deferred();
			
			if (!(request instanceof Request)) {
				console.log('LeaderboardHandler: handleRequest: input was not of type Request');
				var result = new Result(constants.NativeCallResultCode.REQUEST_ERROR, {});
		        dfd.resolve(result);
			} else {
			    console.log('LeaderboardHandler: handleRequest: message is: ' + JSON.stringify(request.getType()));
				// Defer to appropriate handler based on whether user is a guest or is recognized
                ServiceFactory.getGCSettings().getGuestMode().always(function(globalGuestMode) {
				    var targetHandler = undefined;
					
				    var isGuest = globalGuestMode;
					if (isGuest) {
					    targetHandler = leaderboardHandlerGuest;
					} else {
					    targetHandler = leaderboardHandlerRecognized;
					}
					
					targetHandler.handleRequest(request).always(function(result) {
					    // We are acting as a pass-through.  Just return the result.
					    dfd.resolve(result);
					});
                });
		    }
			
			console.log('LeaderboardHandler: handleRequest: end of call');
			return dfd.promise();
		};
    };

    return constructor;
}());
console.log("LeaderboardHandler loaded.");