/*************************************************************/
/* LEADERBOARD SERVICE PROXY                                 
 *
 *	ONES WE NEED FOR NOW
 *	-------------------- 
 *	getLeaderboardsForGame
 *	submitScore
 *	getHighScore
 *	getLeaderboardRanks
 *	getLeaderboardPercentiles
*/
/*************************************************************/

LeaderboardServiceProxy = (function() {
    var constructor = function() {
		/* public functions */
	    this['getLeaderboardsForGame'] = function(gameId) {
		    console.log('LeaderboardServiceProxy: getLeaderboardsForGame');
			var dfd = $.Deferred();
			var args = {};
			args['gameId'] = gameId;
			NativeTransport.serviceCall({target: "LeaderboardsService", method: "getLeaderboardsForGame", guestModeMethod: "getLeaderboardsForGamePublic", args: args}).always(function(responseJson, resultCode) {
			    console.log('LeaderboardServiceProxy: getLeaderboardsForGame complete: ' + JSON.stringify(responseJson));
				/* TODO: Follow these steps */
				/* Step 1: Check resultCodes for validation */
				/* Step 2: Attempt to construct the response objects with the data available */
				/* Step 3: Depending on the outcome of steps 1 and 2, declare this a success or a failure and tag the result with that data */
				/* Step 4: Call the callback provided with our response */
				
				dfd.resolve(responseJson, resultCode);
			});
			
			return dfd.promise();
		};
		
	    this['getHighScore'] = function(gameId, leaderboardId, leaderboardFilter) {
		    console.log('LeaderboardServiceProxy: getHighScore');
			var dfd = $.Deferred();
			var args = {};
			args['gameId'] = gameId;
			args['LeaderboardId'] = leaderboardId;
			args['Scope'] = leaderboardFilter;
			NativeTransport.serviceCall({target: "LeaderboardsService", method: "getHighScore", args: args}).always(function(responseJson, resultCode) {
			    console.log('LeaderboardServiceProxy: getHighScore complete: ' + JSON.stringify(responseJson));
				dfd.resolve(responseJson, resultCode);
			});
			
			return dfd.promise();
		};
		
		this['getLeaderboardRanks'] = function(gameId, leaderboardId, leaderboardFilter, startRank, count) {
		    console.log('LeaderboardServiceProxy: getLeaderboardRanks');
			var dfd = $.Deferred();
			var args = {};
			args['gameId'] = gameId;
			args['LeaderboardId'] = leaderboardId;
			args['Scope'] = leaderboardFilter;
			args['StartRank'] = startRank;
			args['NumRanks'] = count;
			args['FriendsEnabled'] = false;
			NativeTransport.serviceCall({target: "LeaderboardsService", method: "getLeaderboardRanks", guestModeMethod: "getLeaderboardRanksPublic", args: args}).always(function(responseJson, resultCode) {
			    console.log('LeaderboardServiceProxy: getLeaderboardRanks complete: ' + JSON.stringify(responseJson));
				dfd.resolve(responseJson, resultCode);
			});
			
			return dfd.promise();
		};
		
		this['getLeaderboardPercentiles'] = function(gameId, leaderboardId, leaderboardFilter) {
		    console.log('LeaderboardServiceProxy: getLeaderboardPercentiles');
			var dfd = $.Deferred();
			var args = {};
			args['gameId'] = gameId;
			args['LeaderboardId'] = leaderboardId;
			args['Scope'] = leaderboardFilter;
			args['FriendsEnabled'] = false;
			NativeTransport.serviceCall({target: "LeaderboardsService", method: "getLeaderboardPercentiles", guestModeMethod: "getLeaderboardPercentilesPublic", args: args}).always(function(responseJson, resultCode) {
			    console.log('LeaderboardServiceProxy: getLeaderboardPercentiles complete: ' + JSON.stringify(responseJson));
				dfd.resolve(responseJson, resultCode);
			});
			
			return dfd.promise();
		};

		this['submitScore'] = function(gameId, leaderboardId, score) {
		    console.log('LeaderboardServiceProxy: submitScore');
			var dfd = $.Deferred();
			var args = {};
			args['gameId'] = gameId;
			args['LeaderboardId'] = leaderboardId;
			args['PlayerScore'] = score;
			NativeTransport.serviceCall({target: "LeaderboardsService", method: "submitScore", args: args}).always(function(responseJson, resultCode) {
			    console.log('LeaderboardServiceProxy: submitScore complete: ' + JSON.stringify(responseJson));
				dfd.resolve(responseJson, resultCode);
			});
			
			return dfd.promise();
		};
    };  
		
    return constructor;
}());
console.log("LeaderboardServiceProxy loaded.");
