function handleMessage(nativeRequestData) {
    /* TODO: Add null checks to everything (for all our files).  For example if the service call fails, then "params" will be null. */
	/* TODO: Validate message integrity */
    console.log("staging: handleMessage called: nativeRequestData: " + JSON.stringify(nativeRequestData));
	
	var apiRequest = ServiceFactory.getRequestFactory().createAPIRequest(nativeRequestData);
	
	var promise = ServiceFactory.getRequestRouter().handleRequest(apiRequest);
	if (promise != undefined) {
		promise.always(function(result) {
			/* TODO: Validate data integrity */
			/* TODO: Consider having a more structured expected type on Native side.  Maybe: {type:TYPE, response:{}} */
			console.log('staging: handleMessage: callback called');

			var reply = {};
			var replyCode = constants.ServiceResponseCode.SERVICE_REQUEST_FAILURE; /* TODO: Decide if we just want to use RESPONSE_ERROR_UNRECOVERABLE */
			
			if (result instanceof Result) {
			    /* TODO: Abstract away native call result to service response code mapping */
				if (result.getType() == constants.NativeCallResultCode.SUCCESS) {
					replyCode = constants.ServiceResponseCode.SERVICE_REQUEST_SUCCESS;
				} else if (result.getType() == constants.NativeCallResultCode.NETWORK_ERROR) {
				    replyCode = constants.ServiceResponseCode.RESPONSE_ERROR_NETWORK;
				} else if (result.getType() == constants.NativeCallResultCode.AUTHORIZATION_ERROR) {
				    replyCode = constants.ServiceResponseCode.RESPONSE_ERROR_UNAUTHORIZED;
				} else {
				    replyCode = constants.ServiceResponseCode.RESPONSE_ERROR_UNRECOVERABLE;
				}
				reply = $.extend({}, reply, result.getResultMap());
		    }
			
			reply[constants.BindingKeys.REQUEST_ID_KEY] = nativeRequestData[constants.BindingKeys.REQUEST_ID_KEY];
			reply[constants.ServiceResponseCode.RESPONSE_CODE_KEY] = replyCode;
			console.log('staging: Would have ended with: ' + JSON.stringify(reply));
			hostinterface.sendReply(JSON.stringify(reply));
		});
	} else {
		console.log('staging: handleMessage: promise was undefined');

		var reply = {};
		reply[constants.BindingKeys.REQUEST_ID_KEY] = nativeRequestData[constants.BindingKeys.REQUEST_ID_KEY];
		reply[constants.ServiceResponseCode.RESPONSE_CODE_KEY] = constants.ServiceResponseCode.SERVICE_REQUEST_FAILURE; /* TODO: Decide if we just want to use RESPONSE_ERROR_UNRECOVERABLE */
		console.log('staging: Would have ended with no promise and return of: ' + JSON.stringify(reply));
		hostinterface.sendReply(JSON.stringify(reply));
	}
}

hostinterface.setReadyForMessages();
console.log("nativemessageinterface loaded.");