/*
 * Copyright 2013 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * AMAZON.COM CONFIDENTIAL
 */

function loginClick() {
    var task = {};
    task[constants.ServiceActionCode.ACTION_CODE_KEY] = constants.ServiceActionCode.AUTHENTICATE;
    var promise = NativeTransport.callNative({nativeCall:'backgroundTask',args:task});
    hostinterface.closeOverlay();
}

function corClick(cor) {
    var task = {};
    task[constants.ServiceActionCode.ACTION_CODE_KEY] = constants.ServiceActionCode.UPDATE_COUNTRY_OF_RESIDENCE;
    task[constants.BindingKeys.COUNTRY_OF_RESIDENCE] = cor;
    var promise = NativeTransport.callNative({nativeCall:'backgroundTask',args:task});
    hostinterface.closeOverlay();
}

function tosClick() {
    var task = {};
    task[constants.ServiceActionCode.ACTION_CODE_KEY] = constants.ServiceActionCode.AUTHENTICATE;
    var promise = NativeTransport.callNative({nativeCall:'backgroundTask',args:task});
    hostinterface.closeOverlay();
}

/* NOTE: Page.* comes from GameCircleMobileScripts */
function handleOverlayData(overlayData) {
    initData = {};
    if (overlayData != null) {
	    if (overlayData['clientVersion']) {
		    initData['clientVersion'] = overlayData['clientVersion'];
		}
        var actionCode = overlayData[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY];
    
        if (actionCode == constants.OverlayActionCode.SHOW_LOGIN) {
		    initData['initialPage'] = Page.FTUELogin;
			/* Entry point into GameCircleMobileScripts for overlay */
            window.onPlatformReady(initData);
        }  else if (actionCode == constants.OverlayActionCode.SHOW_TERMS_OF_SERVICE) {
            initData['initialPage'] = Page.FTUETOS;
			/* Entry point into GameCircleMobileScripts for overlay */
			window.onPlatformReady(initData);
        } else if (actionCode == constants.OverlayActionCode.SHOW_COR_SELECTION) {
            initData['initialPage'] = Page.FTUECORSelection;
			/* Entry point into GameCircleMobileScripts for overlay */
            window.onPlatformReady(initData);
        } else if (actionCode == constants.OverlayActionCode.SHOW_ACHIEVEMENTS) {
            initData['initialPage'] = Page.Achievements;
			/* Entry point into GameCircleMobileScripts for overlay */
            window.onPlatformReady(initData);
        } else if (actionCode == constants.OverlayActionCode.SHOW_LEADERBOARDS) {
            initData['initialPage'] = Page.Leaderboards;
			/* Entry point into GameCircleMobileScripts for overlay */
            window.onPlatformReady(initData);
		} else if (actionCode == constants.OverlayActionCode.SHOW_PROFILE) {
            initData['initialPage'] = Page.Profile;
			/* Entry point into GameCircleMobileScripts for overlay */
            window.onPlatformReady(initData);
        } else {
            $('body').append('<p>Overlay page: ' + actionCode + '</p>');
            $('body').append('<p><a href="javascript:hostinterface.closeOverlay();">Close Overlay</a></p>');
        }
    } else {
        $('body').append('<p>No overlay data!</p>');
        $('body').append('<p><a href="javascript:hostinterface.closeOverlay();">Close Overlay</a></p>');
    }

}

hostinterface.setReadyForMessages();
console.log("overlaymessageinterface loaded.");
