/*
 * Copyright 2013 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * AMAZON.COM CONFIDENTIAL
 */

ProfileOfflineCache = (function() {
    var constructor = function() {

        this['getCachedProfile'] = function(playerId) {
            console.log('ProfileOfflineCache: getCachedProfile');
            var dfd = $.Deferred();
            var args = {};
            args['primaryKey'] = playerId;
            var promise = NativeTransport.serviceCall({target: constants.OfflineCacheTypes.PLAYER_PROFILE_CACHE, method: "getCacheItem", args: args});
            
            promise.done(function(responseJson, resultCode) {
                console.log('ProfileOfflineCache: getCachedProfile complete: ' + JSON.stringify(responseJson));
                dfd.resolve(responseJson, resultCode);
            });
            
            return dfd.promise();
        };
        
        this['cacheProfile'] = function(playerId, jsonData) {
            console.log('ProfileOfflineCache: cacheProfile');
            var dfd = $.Deferred();
            var args = {};
            /* TODO: There should be a separator between profile id and playerid on all the caches. */
            var cacheRequest = {'primaryKey': playerId,
                                'secondaryKey': playerId,
                                'jsonData': jsonData};
            args['cacheRequest'] = cacheRequest;
            var promise = NativeTransport.serviceCall({target: constants.OfflineCacheTypes.PLAYER_PROFILE_CACHE, method: "setCacheItem", args: args});
            
            promise.done(function(responseJson, resultCode) {
                console.log('ProfileOfflineCache: cacheProfile complete');
                /* TODO: Validate and decide on return type */
                dfd.resolve(responseJson, resultCode);
            });
            
            return dfd.promise();
        };
    };  
        
    return constructor;
}());
console.log("ProfileOfflineCache loaded.");
