RequestRouter = (function() {
    var constructor = function() {
	    var handlerMap = {}; /* MessageType -> Handler */
		
		this['handleRequest'] = function(request) {
		    var dfd = $.Deferred();
			
			if (request instanceof Request) {
			    var reqType = request.getType();
				var handler = handlerMap[reqType];
				
				if (handler == undefined) {
					console.log('RequestRouter: handleRequest: UNDEFINED HANDLER');
					/* TODO: Localize the expected result types (SUCCESS, FAILURE, etc?) */
					var result = new Result('FAILURE', {});
					dfd.resolve(result);
				} else {
				    console.log('RequestRouter: handleRequest: Handler type selected: ' + handler.getHandledType());
					var promise = handler.handleRequest(request);
					promise.done(function(response) {
						dfd.resolve(response);
					});
				}
			} else {
			    console.log('RequestRouter: handleRequest: input was not of type Request');
				var result = new Result('FAILURE', {});
		        dfd.resolve(result);
			}
			
			return dfd.promise();
		};
		  
		this['registerHandler'] = function(msgType, handler) {
		    /* TODO: Type validation */
			handlerMap[msgType] = handler;
		}
	};  
			
    return constructor;
}());

Request = (function() {
    var constructor = function(reqType, reqParams) {
	    var requestType = reqType;
	    var requestParams = reqParams;

		this['getType'] = function() { return requestType; };
	    this['getParams'] = function() { return requestParams; };
	};
	
	return constructor;
}());

Result = (function() {
    var constructor = function(resType, resMap) {
	    var resultType = resType;
	    var resultMap = resMap;

		this['getType'] = function() { return resultType; };
	    this['getResultMap'] = function() { return resultMap; };
	};
	
	return constructor;
}());
console.log("RequestRouter loaded.");
