/*
 * Copyright 2013 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * AMAZON.COM CONFIDENTIAL
 */

function loginClick() {
    var task = {};
    task[constants.ServiceActionCode.ACTION_CODE_KEY] = constants.ServiceActionCode.AUTHENTICATE;
    var promise = NativeTransport.callNative({nativeCall:'backgroundTask',args:task});
    hostinterface.closeOverlay();
}

function corClick(cor) {
    var task = {};
    task[constants.ServiceActionCode.ACTION_CODE_KEY] = constants.ServiceActionCode.UPDATE_COUNTRY_OF_RESIDENCE;
    task[constants.BindingKeys.COUNTRY_OF_RESIDENCE] = cor;
    var promise = NativeTransport.callNative({nativeCall:'backgroundTask',args:task});
    hostinterface.closeOverlay();
}

function tosClick() {
    var task = {};
    task[constants.ServiceActionCode.ACTION_CODE_KEY] = constants.ServiceActionCode.AUTHENTICATE;
    var promise = NativeTransport.callNative({nativeCall:'backgroundTask',args:task});
    hostinterface.closeOverlay();
}

function handleOverlayData(overlayData) {
    if (overlayData != null) {
        var actionCode = overlayData[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY];
    
        if (actionCode == constants.OverlayActionCode.SHOW_LOGIN) {
            $('body').append('<p><a href="javascript:loginClick();">Sign In</a></p>');
            $('body').append('<p><a href="javascript:hostinterface.closeOverlay();">No Thanks</a></p>');
        } else if (actionCode == constants.OverlayActionCode.SHOW_TERMS_OF_SERVICE) {
            $('body').append('<p><a href="javascript:tosClick();">Click here to accept terms of service</a></p>');
            $('body').append('<p><a href="javascript:hostinterface.closeOverlay();">No Thanks</a></p>');
        } else if (actionCode == constants.OverlayActionCode.SHOW_COR_SELECTION) {
            $('body').append("<p><a href=\"javascript:corClick('valid');\">Click here to select a supported COR</a></p>");
            $('body').append("<p><a href=\"javascript:corClick('not supported');\">Click here if your COR is not supported</a></p>");
            $('body').append("<p><a href=\"javascript:hostinterface.closeOverlay();\">No Thanks</a></p>");
        } else {
            $('body').append('<p>Overlay page: ' + actionCode + '</p>');
            $('body').append('<p><a href="javascript:hostinterface.closeOverlay();">Close Overlay</a></p>');
        }
    } else {
        $('body').append('<p>No overlay data!</p>');
        $('body').append('<p><a href="javascript:hostinterface.closeOverlay();">Close Overlay</a></p>');
    }
}

hostinterface.setReadyForMessages();
